VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   1245
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4485
   LinkTopic       =   "Form1"
   ScaleHeight     =   1245
   ScaleWidth      =   4485
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox Picture2 
      AutoSize        =   -1  'True
      Height          =   1020
      Left            =   3360
      Picture         =   "Form1.frx":0000
      ScaleHeight     =   960
      ScaleWidth      =   960
      TabIndex        =   2
      Top             =   120
      Width           =   1020
   End
   Begin VB.HScrollBar HScroll1 
      Height          =   255
      Left            =   1320
      Max             =   100
      Min             =   -100
      TabIndex        =   1
      Top             =   600
      Width           =   1935
   End
   Begin VB.PictureBox Picture1 
      AutoSize        =   -1  'True
      Height          =   1020
      Left            =   120
      Picture         =   "Form1.frx":3042
      ScaleHeight     =   960
      ScaleWidth      =   960
      TabIndex        =   0
      Top             =   120
      Width           =   1020
   End
   Begin VB.Label Label1 
      Alignment       =   1  'Right Justify
      Caption         =   "Brighter"
      Height          =   255
      Index           =   1
      Left            =   2640
      TabIndex        =   5
      Top             =   960
      Width           =   615
   End
   Begin VB.Label Label1 
      Caption         =   "Darker"
      Height          =   255
      Index           =   0
      Left            =   1320
      TabIndex        =   4
      Top             =   960
      Width           =   615
   End
   Begin VB.Label lblValue 
      Alignment       =   2  'Center
      Caption         =   "0"
      Height          =   255
      Left            =   1320
      TabIndex        =   3
      Top             =   360
      Width           =   1935
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function GetObject Lib "gdi32" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long
Private Declare Function GetDIBits Lib "gdi32" (ByVal aHDC As Long, ByVal hBitmap As Long, ByVal nStartScan As Long, ByVal nNumScans As Long, lpBits As Any, lpBI As BITMAPINFO, ByVal wUsage As Long) As Long
Private Declare Function SetDIBits Lib "gdi32" (ByVal hdc As Long, ByVal hBitmap As Long, ByVal nStartScan As Long, ByVal nNumScans As Long, lpBits As Any, lpBI As BITMAPINFO, ByVal wUsage As Long) As Long
Private Type BITMAP '14 bytes
    bmType As Long
    bmWidth As Long
    bmHeight As Long
    bmWidthBytes As Long
    bmPlanes As Integer
    bmBitsPixel As Integer
    bmBits As Long
End Type
Private Type BITMAPINFOHEADER '40 bytes
    biSize As Long
    biWidth As Long
    biHeight As Long
    biPlanes As Integer
    biBitCount As Integer
    biCompression As Long
    biSizeImage As Long
    biXPelsPerMeter As Long
    biYPelsPerMeter As Long
    biClrUsed As Long
    biClrImportant As Long
End Type
Private Type RGBQUAD
    rgbBlue As Byte
    rgbGreen As Byte
    rgbRed As Byte
    rgbReserved As Byte
End Type
Private Type BITMAPINFO
    bmiHeader As BITMAPINFOHEADER
    bmiColors As RGBQUAD
End Type
Private Const DIB_RGB_COLORS = 0&
Private Const BI_RGB = 0&

Private Const pixR As Integer = 3
Private Const pixG As Integer = 2
Private Const pixB As Integer = 1
Private Sub SetBrightness(ByVal pic1 As PictureBox, ByVal pic2 As PictureBox, ByVal brightness As Single)
Dim bitmap_info As BITMAPINFO
Dim pixels() As Byte
Dim bytes_per_scanLine As Integer
Dim pad_per_scanLine As Integer
Dim X As Integer
Dim Y As Integer
Dim fraction As Single

    ' Get the original picture's bits.
    ' Prepare the bitmap description.
    With bitmap_info.bmiHeader
        .biSize = 40
        .biWidth = Picture1.ScaleWidth
        ' Use negative height to scan top-down.
        .biHeight = -Picture1.ScaleHeight
        .biPlanes = 1
        .biBitCount = 32
        .biCompression = BI_RGB
        bytes_per_scanLine = ((((.biWidth * .biBitCount) + 31) \ 32) * 4)
        pad_per_scanLine = bytes_per_scanLine - (((.biWidth * .biBitCount) + 7) \ 8)
        .biSizeImage = bytes_per_scanLine * Abs(.biHeight)
    End With

    ' Load the bitmap's data.
    ReDim pixels(1 To 4, 1 To Picture1.ScaleWidth, 1 To Picture1.ScaleHeight)
    GetDIBits Picture1.hdc, Picture1.Image, _
        0, Picture1.ScaleHeight, pixels(1, 1, 1), _
        bitmap_info, DIB_RGB_COLORS

    ' Modify the pixels.
    If brightness < 0 Then
        ' Darken.
        fraction = (100 + brightness) / 100
        For Y = 1 To pic1.ScaleHeight
            For X = 1 To pic1.ScaleWidth
                pixels(pixR, X, Y) = fraction * pixels(pixR, X, Y)
                pixels(pixG, X, Y) = fraction * pixels(pixG, X, Y)
                pixels(pixB, X, Y) = fraction * pixels(pixB, X, Y)
            Next X
        Next Y
    Else
        ' Brighten.
        fraction = brightness / 100
        For Y = 1 To pic1.ScaleHeight
            For X = 1 To pic1.ScaleWidth
                pixels(pixR, X, Y) = pixels(pixR, X, Y) + _
                    fraction * (255 - pixels(pixR, X, Y))
                pixels(pixG, X, Y) = pixels(pixG, X, Y) + _
                    fraction * (255 - pixels(pixG, X, Y))
                pixels(pixB, X, Y) = pixels(pixB, X, Y) + _
                    fraction * (255 - pixels(pixB, X, Y))
            Next X
        Next Y
    End If

    ' Display the result.
    SetDIBits Picture2.hdc, Picture2.Image, _
        0, Picture1.ScaleHeight, pixels(1, 1, 1), _
        bitmap_info, DIB_RGB_COLORS
    Picture2.Picture = Picture2.Image
End Sub

Private Sub Form_Load()
    Picture1.ScaleMode = vbPixels
    Picture2.ScaleMode = vbPixels
    Picture1.AutoRedraw = True
    Picture2.AutoRedraw = True
End Sub


Private Sub HScroll1_Change()
    SetBrightness Picture1, Picture2, HScroll1.Value
    lblValue.Caption = Format$(HScroll1.Value)
End Sub

